/*
 * Copyright (C) 2011 Andrey Filkov
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software
 *    in a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 * File:    FConfigReader_r.h
 * Created: October 15, 2011
 */
#ifndef _F_CONFIGREADER_R_H
#define _F_CONFIGREADER_R_H


#include "FConfigReader.h"

class FConfigReader_r : public FConfigReader
{
	FConfigReader_r(){};
	FConfigReader_r(const FConfigReader_r& orig){};
public:
	static FConfigReader_r* CreateInstance(const std::string& file, const char com = '#', const char delim = '=', const char open = '[', const char close = ']');
	virtual ~FConfigReader_r();

	bool ReadConfig();
	void GetSectionNames(std::vector<std::string>& sect);
	void GetSectionData(std::map<std::string,std::string>& keyVal, const std::string& sect = "");
	bool CheckKeys(std::vector<std::string>& keys, const std::string& sect = "");

private:
	pthread_rwlock_t m_lock;
};

#endif	/* _F_CONFIGREADER_R_H */
